<template>
    <el-dialog title="导出预览" top="0" width="100%" :visible.sync="dialogTableVisible" class="preview-dialog" destroy-on-close
        :append-to-body="true" v-if="dialogTableVisible">
        <div data-name="改革报表分档结果" class="index-item">
            <div class="sub-title-content">
                <span>
                    <img class="levelPageTitle2" src="@/assets/img/bigScreen/levelPageTitle2.png" alt="" />
                    <img class="air-title" src="@/assets/img/bigScreen/air-title.png" alt="" />
                </span>
                改革报表分档结果
            </div>
            <mapTargetAll :CQId="mapCQId_all" :main9Id="main9Id_all" :isClick="false"></mapTargetAll>
        </div>
        <div data-name="数字重庆建设进展" class="index-item resvers-item" v-if="exportList[0]">
            <div class="sub-title-content">
                <span>
                    <img class="levelPageTitle2" src="@/assets/img/bigScreen/levelPageTitle2.png" alt="" />
                    <img class="air-title" src="@/assets/img/bigScreen/air-title.png" alt="" />
                </span>
                数字重庆建设进展
            </div>
            <mapTarget9 :CQId="mapCQId_9" :main9Id="main9Id_9" :isClick="false"></mapTarget9>
        </div>
        <div data-name="建立企业上市助推机制进展" class="index-item" v-if="exportList[3]">
            <div class="sub-title-content">
                <span>
                    <img class="levelPageTitle2" src="@/assets/img/bigScreen/levelPageTitle2.png" alt="" />
                    <img class="air-title" src="@/assets/img/bigScreen/air-title.png" alt="" />
                </span>
                建立企业上市助推机制进展
            </div>
            <mapTarget12 :CQId="mapCQId_12" :main9Id="main9Id_12" :isClick="false"></mapTarget12>
        </div>
        <div data-name="打造“信用重庆”升级版进展" class="index-item" v-if="exportList[4]">
            <div class="sub-title-content">
                <span>
                    <img class="levelPageTitle2" src="@/assets/img/bigScreen/levelPageTitle2.png" alt="" />
                    <img class="air-title" src="@/assets/img/bigScreen/air-title.png" alt="" />
                </span>
                打造“信用重庆”升级版进展
            </div>
            <mapTarget13 :CQId="mapCQId_13" :main9Id="main9Id_13" :isClick="false"></mapTarget13>
        </div>
        <div data-name="正在推进中的国家改革试点项目数" class="index-item" v-if="exportList[5]">
            <div class="sub-title-content">
                <span>
                    <img class="levelPageTitle2" src="@/assets/img/bigScreen/levelPageTitle2.png" alt="" />
                    <img class="air-title" src="@/assets/img/bigScreen/air-title.png" alt="" />
                </span>
                正在推进中的国家改革试点项目数
            </div>
            <mapTarget1 :CQId="mapCQId_1" :main9Id="main9Id_1" :isClick="false"></mapTarget1>
        </div>
        <!-- <div data-name="承接市级试点项目数" class="index-item">
            <div class="sub-title-content">
                <span>
                    <img class="levelPageTitle2" src="@/assets/img/bigScreen/levelPageTitle2.png" alt="" />
                    <img class="air-title" src="@/assets/img/bigScreen/air-title.png" alt="" />
                </span>
                承接市级试点项目数
            </div>
            <mapTarget2 :CQId="mapCQId_2" :main9Id="main9Id_2" :isClick="false"></mapTarget2>
        </div> -->
        <!-- <div data-name="承接国家级试点按时通过验收率" class="index-item" v-if="exportList[6]">
            <div class="sub-title-content">
                <span>
                    <img class="levelPageTitle2" src="@/assets/img/bigScreen/levelPageTitle2.png" alt="" />
                    <img class="air-title" src="@/assets/img/bigScreen/air-title.png" alt="" />
                </span>
                承接国家级试点按时通过验收率
            </div>
            <mapTarget3 :CQId="mapCQId_3" :main9Id="main9Id_3" :isClick="false"></mapTarget3>
        </div> -->
        <div data-name="新增国家改革试点项目数" class="index-item" v-if="exportList[7]">
            <div class="sub-title-content">
                <span>
                    <img class="levelPageTitle2" src="@/assets/img/bigScreen/levelPageTitle2.png" alt="" />
                    <img class="air-title" src="@/assets/img/bigScreen/air-title.png" alt="" /> </span>新增国家改革试点项目数
            </div>
            <mapTarget4 :CQId="mapCQId_4" :main9Id="main9Id_4" :isClick="false"></mapTarget4>
        </div>
        <div data-name="改革经验获全国性肯定评价" class="index-item" v-if="exportList[8]">
            <div class="sub-title-content">
                <span>
                    <img class="levelPageTitle2" src="@/assets/img/bigScreen/levelPageTitle2.png" alt="" />
                    <img class="air-title" src="@/assets/img/bigScreen/air-title.png" alt="" /> </span>改革经验获全国性肯定评价
            </div>
            <mapTarget5 :CQId="mapCQId_5" :main9Id="main9Id_5" :isClick="false"></mapTarget5>
        </div>
        <div data-name="改革经验获全市推广" class="index-item" v-if="exportList[9]">
            <div class="sub-title-content">
                <span>
                    <img class="levelPageTitle2" src="@/assets/img/bigScreen/levelPageTitle2.png" alt="" />
                    <img class="air-title" src="@/assets/img/bigScreen/air-title.png" alt="" /> </span>改革经验获全市推广
            </div>
            <mapTarget6 :CQId="mapCQId_6" :main9Id="main9Id_6" :isClick="false"></mapTarget6>
        </div>
        <div data-name="社情民意电话调查满意度" class="index-item" v-if="exportList[10]">
            <div class="sub-title-content">
                <span>
                    <img class="levelPageTitle2" src="@/assets/img/bigScreen/levelPageTitle2.png" alt="" />
                    <img class="air-title" src="@/assets/img/bigScreen/air-title.png" alt="" /> </span>社情民意电话调查满意度
            </div>
            <mapTarget8 :CQId="mapCQId_8" :main9Id="main9Id_8" :isClick="false"></mapTarget8>
        </div>
        <div slot="footer" class="dialog-footer">
            <el-button type="primary" @click="exportImg" :loading="downloadLoading">确认导出</el-button>
        </div>
    </el-dialog>
</template>

<script>
import apiList from '@/api/bigScreen/districView.js'
import html2canvas from 'html2canvas'
import screenHeader from '@/views/BigScreen/components/screenHeader.vue'
import mapTarget1 from '@/views/BigScreen/components/subComponents/mapTarget1.vue' // 重点关注指标
import mapTarget2 from '@/views/BigScreen/components/subComponents/mapTarget2.vue' // 重点关注指标
import mapTarget3 from '@/views/BigScreen/components/subComponents/mapTarget3.vue' // 重点关注指标
import mapTarget4 from '@/views/BigScreen/components/subComponents/mapTarget4.vue' // 重点关注指标
import mapTarget5 from '@/views/BigScreen/components/subComponents/mapTarget5.vue' // 重点关注指标
import mapTarget6 from '@/views/BigScreen/components/subComponents/mapTarget6.vue' // 重点关注指标
import mapTarget7 from '@/views/BigScreen/components/subComponents/mapTarget7.vue' // 重点关注指标
import mapTarget8 from '@/views/BigScreen/components/subComponents/mapTarget8.vue' // 重点关注指标
import mapTarget9 from '@/views/BigScreen/components/subComponents/mapTarget9.vue' // 重点关注指标
import mapTarget12 from '@/views/BigScreen/components/subComponents/mapTarget12.vue' // 重点关注指标
import mapTarget13 from '@/views/BigScreen/components/subComponents/mapTarget13.vue' // 重点关注指标
import mapTargetAll from '@/views/BigScreen/components/subComponents/mapTargetAll.vue' // 重点关注指标
import JSZip from 'jszip'
export default {
    components: {
        screenHeader,
        mapTarget1,
        mapTarget2,
        mapTarget3,
        mapTarget4,
        mapTarget5,
        mapTarget6,
        mapTarget7,
        mapTarget8,
        mapTarget9,
        mapTarget9,
        mapTarget12,
        mapTarget13,
        mapTargetAll
    },
    data() {
        return {
            downloadLoading: false,
            dialogTableVisible: false,
            mapCQId_1: 'cq-contianer_1',
            mapCQId_2: 'cq-contianer_2',
            mapCQId_3: 'cq-contianer_3',
            mapCQId_4: 'cq-contianer_4',
            mapCQId_5: 'cq-contianer_5',
            mapCQId_6: 'cq-contianer_6',
            mapCQId_7: 'cq-contianer_7',
            mapCQId_8: 'cq-contianer_8',
            mapCQId_9: 'cq-contianer_9',
            mapCQId_12: 'cq-contianer_12',
            mapCQId_13: 'cq-contianer_13',
            mapCQId_all: 'cq-contianer_all',
            main9Id_1: 'main9-contianer_1',
            main9Id_2: 'main9-contianer_2',
            main9Id_3: 'main9-contianer_3',
            main9Id_4: 'main9-contianer_4',
            main9Id_5: 'main9-contianer_5',
            main9Id_6: 'main9-contianer_6',
            main9Id_7: 'main9-contianer_7',
            main9Id_8: 'main9-contianer_8',
            main9Id_9: 'main9-contianer_9',
            main9Id_12: 'main9-contianer_12',
            main9Id_13: 'main9-contianer_13',
            main9Id_all: 'main9-contianer_all',
            exportList: [
            ],
            searchDate: null
        }
    },
    mounted() {
        this.searchDate = JSON.parse(sessionStorage.getItem('searchDate'))
        this.getTarget(this.searchDate)
    },
    methods: {
        getScale() {
            const wh = window.innerHeight / 935;
            const ww = window.innerWidth / 1919;
            let bl = ww < wh ? ww : wh
            this.$nextTick(() => {
                let doms = document.querySelectorAll('.index-item')
                Array.from(doms).map((item) => {
                    item.style.transform = `scale(${bl})`
                    item.style.transformOrigin = 'left top'
                    item.style.marginBottom = `-${(1 - bl) * 935}px`
                })
            })
        },
        getTarget(data) {
            apiList
                .getTarget({
                    quarter: data.quarter,
                    year: data.year,
                })
                .then((res) => {
                    if (res.state) {
                        this.exportList[0] = res.value.digitRate || 0
                        this.exportList[1] = 0
                        this.exportList[2] = 0
                        this.exportList[3] = res.value.listedCompaniesDivide || 0
                        this.exportList[4] = res.value.creditRate || 0
                        this.exportList[5] = res.value.nationalProjectNum || 0
                        this.exportList[6] = res.value.nationalPassRate || 0
                        this.exportList[7] = res.value.nationalAddNum || 0
                        this.exportList[8] = res.value.nationwideNum || 0
                        this.exportList[9] = res.value.cityNum || 0
                        this.exportList[10] = res.value.satisfied || 0
                        this.exportList[11] = res.value.all || 0
                    }
                })
        },
        open() {
            let { comp } = this.$route.query
            if (comp == 'mapTarget_1') {
                this.mapCQId_1 = 'dialog-map_1'
                this.main9Id_1 = 'main9-dialog_1'
            } else if (comp == 'mapTarget_2') {
                this.mapCQId_2 = 'dialog-map_2'
                this.main9Id_2 = 'main9-dialog_2'
            } else if (comp == 'mapTarget_3') {
                this.mapCQId_3 = 'dialog-map_3'
                this.main9Id_3 = 'main9-dialog_3'
            } else if (comp == 'mapTarget_4') {
                this.mapCQId_4 = 'dialog-map_4'
                this.main9Id_4 = 'main9-dialog_4'
            } else if (comp == 'mapTarget_5') {
                this.mapCQId_5 = 'dialog-map_5'
                this.main9Id_5 = 'main9-dialog_5'
            } else if (comp == 'mapTarget_6') {
                this.mapCQId_6 = 'dialog-map_6'
                this.main9Id_6 = 'main9-dialog_6'
            } else if (comp == 'mapTarget_7') {
                this.mapCQId_7 = 'dialog-map_7'
                this.main9Id_7 = 'main9-dialog_7'
            } else if (comp == 'mapTarget_8') {
                this.mapCQId_8 = 'dialog-map_8'
                this.main9Id_8 = 'main9-dialog_8'
            } else if (comp == 'mapTarget_9') {
                this.mapCQId_9 = 'dialog-map_9'
                this.main9Id_9 = 'main9-dialog_9'
            } else if (comp == 'mapTarget_12') {
                this.mapCQId_12 = 'dialog-map_12'
                this.main9Id_12 = 'main9-dialog_12'
            } else if (comp == 'mapTarget_13') {
                this.mapCQId_13 = 'dialog-map_13'
                this.main9Id_13 = 'main9-dialog_13'
            }  else if (comp == 'mapTarget_All') {
                this.mapCQId_all = 'dialog-map_all'
                this.main9Id_all = 'main9-dialog_all'
            }
            this.dialogTableVisible = true
            // this.openSetHeight()
            this.getScale()
                    },
        close() {
            this.dialogTableVisible = false
            this.elementId = null
        },
        // openSetHeight() {
        //     this.$nextTick(() => {
        //         var parentElement = document.querySelector('.resvers-item');
        //         console.log(parentElement);
        //         var childElements1 = parentElement.querySelector('.map-target');
        //         var childElements2 = childElements1.querySelector('.list-container');
        //         var childElements3 = childElements2.querySelector('.airTable');
        //         var childElements4 = childElements3.querySelector('.box-list');
        //         var childElements5 = childElements4.querySelector('div');
        //         if (childElements5) {
        //             console.log(childElements5);
        //         }

        //     })
        // },
        exportImg() {
            this.downloadLoading = true
            this.$message({
                message: "文件导出可能较慢，请耐心等候...",
                center: true,
                type: "warning",
                duration: 0,
            })
            setTimeout(async () => {
                let doms = document.querySelectorAll(".index-item")
                let cloneDoms = Array.from(doms).map(dom => dom.cloneNode(true))
                let elBody = document.getElementsByClassName("el-dialog__body")[0]
                cloneDoms.forEach(item => elBody.appendChild(item))
                let imgUrl = []
                let promises = cloneDoms.map((item) => {
                    let name = item.getAttribute("data-name") + ".png"
                    item.style.transform = "none"
                    return html2canvas(item, {
                        allowTaint: true,
                        scale: 1,
                        backgroundColor: "#072d62",
                        useCORS: true,
                        allowTaint: true,
                        logging: false,
                        removeContainer: true,
                        width: 1920,
                        height: 935,
                    }).then((canvas) => {
                        let img = new Image()
                        img.src = canvas.toDataURL("image/png")
                        return new Promise((resolve) => {
                            img.onload = () => {
                                imgUrl.push({
                                    name,
                                    url: getResizedImageData(img, 1920, 935),
                                })
                                resolve()
                            }
                        })
                    })
                })

                await Promise.allSettled(promises)
                cloneDoms.forEach(item => elBody.removeChild(item))
                let zip = new JSZip()
                imgUrl.forEach((file) => {
                    zip.file(file.name, file.url, { base64: true })
                })

                zip.generateAsync({ type: "blob" }).then((content) => {
                    saveAs(content, "改革报表指标晾晒.zip")
                    this.downloadLoading = false
                    this.$message.closeAll()
                    this.getScale()
                    this.$message.success("导出文件成功")
                })

                // 根据目标宽度和高度将图片进行缩放
                function getResizedImageData(image, targetWidth, targetHeight) {
                    let canvas = document.createElement("canvas")
                    let context = canvas.getContext("2d")
                    canvas.width = targetWidth
                    canvas.height = targetHeight
                    context.drawImage(image, 0, 0, targetWidth, targetHeight)
                    return canvas.toDataURL("image/png").split(";base64,")[1]
                }
            }, 100)
        }
    },
}
</script>

<style lang="scss" scoped>
/deep/.detail-btn {
    display: none;
}
/deep/.el-dialog__wrapper {
    position: fixed;
    top: 0;
}

/deep/.el-dialog {
    height: 100%;
    margin: 0;
    padding: 0;
}

.index-item {
    width: 1919PX;
    height: 935PX;
    padding: 0 20PX 43PX;
    box-sizing: border-box;
}

.scale-item {
    transform: scale(0.8);
    transform-origin: left top;
}

/deep/.el-dialog__footer,
/deep/.el-dialog__header {
    background: #072d62;
}

/deep/.el-dialog__footer {
    position: absolute;
    width: 100%;
    bottom: 0;
}

/deep/.el-dialog__header {
    background-color: #072d62;
    color: #fff;

    span {
        color: #fff;
    }
}

/deep/.el-dialog__headerbtn .el-dialog__close {
    color: #fff !important;
}

/deep/.el-dialog__body {
    // width: 100vw;
    max-height: 88vh;
    overflow-x: hidden;

    >* {
        letter-spacing: 2PX;
    }

    margin: 0;
    padding: 0;
    background: #072d62;
    // .box-list .box-list-title p {
    //   height: 32px;
    //   line-height: 32px;
    // }
    // .box-list .box-list-tr.box-list-th p {
    //   font-size: 16px;
    // }
    // .box-list .box-list-tr p {
    //   font-size: 18px;
    // }
    // .box-list-title p {
    //   font-size: 24px !important;
    // }

    .sub-title-content {
        // padding: 0 0 10px 22px;
        width: 100%;
        font-size: 24PX;
        letter-spacing: 2PX;
        line-height: 60PX;
        color: #fff;
        position: relative;
        // text-shadow: 0px 0px 0.83333vw #4683fd;
        padding-left: 30PX;

        .levelPageTitle2 {
            width: 25PX;
            height: 40PX;
            position: absolute;
            top: 50%;
            transform: translateY(-50%);
            left: 5PX;
        }

        .air-title {
            width: 40PX;
            position: absolute;
            top: 50%;
            transform: translateY(-50%);
            left: -5PX;
        }
    }

    .map-tip-container {
        width: 868PX;
        margin-left: 30PX;

        // margin-right: 30px;
        .map-container {
            height: 520PX;
            margin-bottom: 28PX;
        }
    }

    .list-container {
        width: 927PX;

        >* {
            font-family: 'Microsoft YaHei', sans-serif;
        }

        // height: 824PX;
        // flex: 1;
        // margin-left: 24px;
    }

    .sub-title-content::before {
        content: '';
        position: absolute;
        left: 10PX;
        top: 5PX;
        width: 50PX;
        height: 50PX;
        // background: url('~@/assets/img/bigScreen/levelPageTitle2.png') no-repeat;
        background-size: cover;
    }

    .sub-title-content::after {
        content: '';
        position: absolute;
        left: 10PX;
        top: 5PX;
        width: 50PX;
        height: 50PX;
        // background: url('~@/assets/img/bigScreen/air-title.png') no-repeat;
        background-size: cover;
    }

    .map-target {
        padding: 8PX 0 0 0;
        width: 100%;
        height: 832PX;
        box-sizing: border-box;
        gap: 0;
    }

    .map-tip .tip-item .tip-text {
        font-size: 18PX;
        // line-height: 40PX;
    }

    .map-tip .tip-item .level-title {
        font-size: 18PX;
        line-height: 37PX;
    }
}

/deep/::-webkit-scrollbar {
    width: 0 !important;
}

/deep/ .map-tip {
    // bottom: 14PX;
    bottom: 16px;
}

.resvers-item {
    /deep/ .box-list {
        flex-direction: row-reverse;

        :first-child {
            .box-list-tr {
                height: 54.0667PX !important;
            }

            // >* {
            //     // height: 53.3333PX !important;
            //     // height: 54.0667PX !important;
            // }
        }
    }
}
</style>
